module helicon2_sub

  use adj_mod
  use helicon2
  use subtract
  use helix
  use chain_mod
  implicit none

  real, dimension(:), allocatable :: tmp

  contains
  subroutine helicon2_sub_init (pef_in,nd)
    type( filter)        ::    pef_in
    integer              ::           nd
    call helicon2_init(pef_in)
    allocate(tmp(nd))
  end subroutine
  function helicon2_sub_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call helicon2_sub_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine helicon2_sub_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    tmp=0
    call chain2(helicon2_lop,subtract_lop,adj,.true.,xx,yy,tmp)
  end subroutine 
  subroutine helicon2_sub_close()
    deallocate(tmp)
    call helicon2_close()
  end subroutine 
end module 
