module subtract

  use adj_mod
  implicit none

  contains
  subroutine subtract_init ()
  end subroutine
  function subtract_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj, add 
    real,dimension(:)  ::           xx, yy 
    call adjnull (adj,add,xx,yy ) 
    call subtract_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine subtract_lop2(adj,xx,yy)
    logical,intent(in) ::  adj 
    real, dimension (:)  ::    xx 
    real, dimension (:)  ::       yy 
    integer              :: i
    if (adj) then
       do i=1,size(xx)
          xx(i) = xx(i) - yy(i)
       end do
    else
       do i=1,size(xx)
          yy(i) = yy(i) - xx(i)
       end do
    end if
  end subroutine 
  subroutine subtract_close()
  end subroutine 
end module 
