module peff2ns

  use adj_mod
  use nhelicon
  use nhelicon2
  use nhelix
  use chain_mod
  implicit none
  contains
  subroutine peff2ns_init (pef1_in,pef2_in)
    type(nfilter)    ::    pef1_in,pef2_in
    call nhelicon_init(pef1_in)
    call nhelicon2_init(pef2_in)
  end subroutine
  function peff2ns_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call peff2ns_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine peff2ns_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
!write(0,*)"mad2pef lop",nd,size(xx),size(yy)
    call array(nhelicon_lop,nhelicon2_lop,adj,.true.,xx,yy,yy)
  end subroutine 
  subroutine peff2ns_close()
    call nhelicon_close()
    call nhelicon2_close()
  end subroutine 
end module 
