Program Grid2points

  use sep
  use cartesian
  use read_hist_param
  use error_check
  implicit none

  integer                           :: dim, i, j
  integer, dimension(:),allocatable :: nn, ii
  real,    dimension(:),pointer     :: oo,dd, data
  real,    dimension(:,:),pointer   :: outdata


  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim),ii(dim))

  call history_read(nn,oo,dd)
write(0,*)"Main 3"

  allocate(data(product(nn)))
  allocate(outdata(product(nn),dim+1))
write(0,*)"Main 4"

  call sep_read(data)
write(0,*)"Main 5"
  do i=1,size(data)
     call line2cart(nn,i,ii)
     do j=1,dim
        outdata(i,j) = oo(j)+((ii(j)-1)*dd(j))
     end do
  end do
  outdata(:,dim+1)=data

! write out movies
  call to_history("n1",product(nn))
  call to_history("n2",dim+1)
  call to_history("o1",1)
  call to_history("o2",1)
  call to_history("d1",1)
  call to_history("d2",1)

  call sep_write(outdata)

  deallocate(nn,oo,dd,data,outdata)
end Program Grid2points
