Program Lapfill

  use sep
  use lapfilln
  use read_hist_param
  use error_check
  implicit none

  integer                           :: dimm,ndat,niter,stat,lintl
  integer, dimension(:),allocatable :: nn,fn
  real,    dimension(:),pointer :: oo,dd,fo,fd,data,mask,points,model
  logical, dimension(:),pointer :: maskl
  real                          :: eps

write(0,*)"LapFill start"

  call sep_init(SOURCE)
  dimm = sep_dimension()

write(0,*)"Fill start2"
  allocate(nn(dimm),oo(dimm),dd(dimm))
  
  call history_read(nn,oo,dd)
  call from_param("niter",niter,100)
  call from_param("lint",lintl,0)
  call from_param("eps",eps,1.)


  write(0,*)"Fill par read",nn,oo,dd,niter

  ndat=product(nn)
  allocate(data(ndat),mask(ndat),maskl(ndat),model(ndat))

  call sep_read(data)
  call sep_read(mask,"mask")
write(0,*)"Fill data, mask and pef read"
  maskl=.false.
  where (mask==0) maskl=.true.
  deallocate(mask)

write(0,*)"Fill change mask"

if (lintl==0) then
  call lapfill (niter,nn,data,maskl)
else
write(0,*)"Fill before laplfill"
  call laplfill (data,model,maskl,nn,oo,dd,niter,eps)
write(0,*)"Fill after laplfill"
end if
  write(0,*)"Fill after main call"

if (lintl==0) then
  call rmms(data,"data ")
  call sep_write(data)
else
  call rmms(model,"model")
  call sep_write(model)
end if

  call sep_close()
  deallocate(data,maskl,nn,oo,dd)
end Program Lapfill
