program Laplacian
  use laplac2
  use sep

  implicit none
  integer                          :: na, stat, n1, n2, n12, i3, n3
  real, dimension (:), allocatable :: pp, qq


  call sep_init (SOURCE)
  call from_history (n1, n2, n3)
  call sep_close ()

  n12 = n1*n2
  allocate (pp(n12), qq(n12))

  call laplac2_init (n1, n2)
  call sep_read ( pp)
  stat = laplac2_lop (.false.,.false., pp, qq)
  call sep_write( qq)
  call laplac2_close()
  deallocate (pp, qq)
  call exit (0)
end program Laplacian
