module mad2pef

  use adj_mod
  use helicon_sub
  use helicon2_sub
  use helix
  use chain_mod
  implicit none


  integer :: nd
  contains
  subroutine mad2pef_init (pef1_in,pef2_in,nd_in)
    type( filter)    ::    pef1_in,pef2_in
    integer          :: nd_in
    nd = nd_in
    call helicon_sub_init(pef1_in,nd)
    call helicon2_sub_init(pef2_in,nd)
  end subroutine
  function mad2pef_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call mad2pef_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine mad2pef_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
!write(0,*)"mad2pef lop",nd,size(xx),size(yy)
    call array(helicon_sub_lop,helicon2_sub_lop,adj,.true.,xx,yy(1:nd),yy(nd+1:2*nd))

  end subroutine 
  subroutine mad2pef_close()
    call helicon_sub_close()
    call helicon2_sub_close()
  end subroutine 
end module 
